class Message {
    constructor(d, client) {
        this.raw = d;
        this.id = d.id;
        this.content = d.content;
        this.author = d.author;
        this.member = d.member || null;
        this.timestamp = d.timestamp;
        this.editedTimestamp = d.edited_timestamp;
        this.tts = d.tts;
        this.mentionEveryone = d.mention_everyone;
        this.mentions = d.mentions;
        this.roleMentions = d.mention_roles;
        this.attachments = d.attachments;
        this.embeds = d.embeds;
        this.reactions = d.reactions;
        this.nonce = d.nonce;
        this.pinned = d.pinned;
        this.type = d.type;
        this.channel = client.channels.get(d.channel_id);
        this.guild = client.guilds.get(d.guild_id);
    }
};

module.exports = Message;