class Collection extends Map {
    constructor(iterable) {
        super(iterable);
    }

    array() {
        return Array.from(this.values());
    }

    keyArray() {
        return Array.from(this.keys());
    }

    first() {
        return this.values().next().value;
    }

    firstKey() {
        return this.keys().next().value;
    }

    last() {
        let arr = this.array();
        return arr[arr.length - 1];
    }

    lastKey() {
        let arr = this.keyArray();
        return arr[arr.length - 1];
    }

    random() {
        let arr = this.array();
        return arr[Math.floor(Math.random() * arr.length)];
    }

    find(property, value) {
        for(const x of this.values()) {
            if(x[property === value]) return x;
        }
    }

    clone() {
        return new this.constructor(this);
    }
};

module.exports = Collection;