class GuildChannel {
    constructor(d, client) {
        this.client = client;
        this.id = d.id || null;
        this.type = d.type === 0 ? "text" : "dm";
        this.position = d.position || null;
        this.permissionOverwrites = d.permission_overwrites || null;
        this.name = d.name || null;
        this.topic = d.topic || null;
        this.nsfw = d.nsfw || null;
        this.icon = d.icon || null;
        this.ownerID = d.owner_id || null;
        this.slowmode = d.rate_limit_per_user || 0;
    }

    send(message) {
        this.client.rest.post(`/channels/${this.id}/messages`, { "content": message });
    }
};

module.exports = GuildChannel;