class Logger {
    constructor() {
        throw new Error("Logger class should not be initialized.");
    }

    static info(message) {
        console.log("\x1b[42m\x1b[30mINFO\x1b[0m \x1b[32m%s\x1b[0m", message);
    }

    static debug(message) {
        console.log("\x1b[47m\x1b[30mDEBUG\x1b[0m \x1b[34m%s\x1b[0m", message);
    }

    static error(message) {
        console.error("\x1b[41mERROR\x1b[0m \x1b[31m%s\x1b[0m", message);
    }

    static warn(message) {
        console.warn("\x1b[43m\x1b[30mWARN\x1b[0m \x1b[33m%s\x1b[0m", message);
    }
};

module.exports = Logger;